function paper_plot_gold_ball()
    dir = '.';%'results_gold_ball_8-13';
%     dir2 = 'results_gold_ball_LRFISTA';

    load([dir '/GlodBall_LRBFGS_20_0_6.mat']);
    x0 = x0 / norm(x0);
    
    set(0,'defaultaxesfontsize',15, ...
       'defaultaxeslinewidth',0.7, ...
       'defaultlinelinewidth',.8,'defaultpatchlinewidth',0.8);
    set(0,'defaultlinemarkersize',10)

    x1 = abs(x0);
    nv = 64 / max(x1(:));
    figure(1);clf
    image(x1 * nv);
    h = colorbar('YTick', [1, 64], 'YTickLabel', {'min', 'max'});
    set(h, 'ylim', [1 64])
    axis off
    
    amplification = 10;
    ls = [6, 32];
    taus = [20, 40, Inf];
    for i = 1 : length(taus)
        load([dir '/GlodBall_LRBFGS_' num2str(taus(i)) '_0_' num2str(ls(1)) '.mat']);
        aaa = load([dir '/GlodBall_LRBFGS_' num2str(taus(i)) '_0_' num2str(ls(1)) '.mat']);
        ssnr = aaa.snr;
        x0 = x0 / norm(x0);
        LRBFGSend = recover_x(LRBFGSend, x0);
        figure(i+1);clf
        set(gcf,'Position',[100,100,780,300]);
        subplot(1, 2, 1);
        image(abs(LRBFGSend) * nv);
        title([num2str(ls(1)) ' Gaussian masks, SNR: ' num2str(taus(i))]);
        axis off
        subplot(1, 2, 2);
        image((abs(x0 - LRBFGSend)) * nv * amplification);
        title([num2str(amplification) ' times error']);
        axis off
        fprintf('Gaussian SNR:%e, LRBFGSmse:%e, %e dB, time: %f\n', ssnr, LRBFGSmse, 10 * log(LRBFGSmse) / log(10), LRBFGSt);
    end
    for j = 1 : length(ls)
        for i = 1 : length(taus)
            load([dir '/GlodBall_LRBFGS_' num2str(taus(i)) '_1_'  num2str(ls(j)) '.mat']);
            aaa = load([dir '/GlodBall_LRBFGS_' num2str(taus(i)) '_1_'  num2str(ls(j)) '.mat']);
            ssnr = aaa.snr;
            x0 = x0 / norm(x0);
            LRBFGSend = recover_x(LRBFGSend, x0);
            figure(i+1+length(taus) * j);clf
            set(gcf,'Position',[100,100,780,300]);
            subplot(1, 2, 1);
            image(abs(LRBFGSend) * nv);
            title([num2str(ls(j)) ' Binary masks, SNR: ' num2str(taus(i))]);
            axis off
            subplot(1, 2, 2);
            image((abs(x0 - LRBFGSend)) * nv * amplification);
            title([num2str(amplification) ' times error']);
            axis off
            fprintf('Binary: SNR:%e, LRBFGSmse:%e, %e dB, time: %f\n', ssnr, LRBFGSmse, 10 * log(LRBFGSmse) / log(10), LRBFGSt);
        end
    end
%     
%     for i = 1 : length(taus)
%         load([dir '/GlodBall_LRFISTA_' num2str(taus(i)) '_0_' num2str(ls(1)) '.mat']);
%         aaa = load([dir '/GlodBall_LRFISTA_' num2str(taus(i)) '_0_' num2str(ls(1)) '.mat']);
%         ssnr = aaa.snr;
%         x0 = x0 / norm(x0);
%         LRFISTAend = recover_x(LRFISTAend, x0);
%         figure(i+1 +length(taus)*2);clf
%         set(gcf,'Position',[100,100,780,300]);
%         subplot(1, 2, 1);
%         image(abs(LRFISTAend) * nv);
%         title([num2str(ls(1)) ' Gaussian masks, SNR: ' num2str(taus(i))]);
%         axis off
%         subplot(1, 2, 2);
%         image((abs(x0 - LRFISTAend)) * nv * amplification);
%         title([num2str(amplification) ' times error']);
%         axis off
%         fprintf('Gaussian SNR:%e, LRFISTAmse:%e, %e dB, time: %f\n', ssnr, LRFISTAmse, 10 * log(LRFISTAmse) / log(10), LRFISTAt);
%     end
%     for j = 1 : length(ls)
%         for i = 1 : length(taus)
%             load([dir '/GlodBall_LRFISTA_' num2str(taus(i)) '_1_'  num2str(ls(j)) '.mat']);
%             aaa = load([dir '/GlodBall_LRFISTA_' num2str(taus(i)) '_1_' num2str(ls(1)) '.mat']);
%             ssnr = aaa.snr;
%             x0 = x0 / norm(x0);
%             LRFISTAend = recover_x(LRFISTAend, x0);
%             figure(i+1+length(taus)*3 * j);clf
%             set(gcf,'Position',[100,100,780,300]);
%             subplot(1, 2, 1);
%             image(abs(LRFISTAend) * nv);
%             title([num2str(ls(j)) ' Binary masks, SNR: ' num2str(taus(i))]);
%             axis off
%             subplot(1, 2, 2);
%             image((abs(x0 - LRFISTAend)) * nv * amplification);
%             title([num2str(amplification) ' times error']);
%             axis off
%             fprintf('Gaussian SNR:%e, LRFISTAmse:%e, %e dB, time: %f\n', ssnr, LRFISTAmse, 10 * log(LRFISTAmse) / log(10), LRFISTAt);
%         end
%     end
end

function output = recover_x(xx, pp)
    x = reshape(xx, [], 1);
    phase = reshape(pp, [], 1);
    X1 = [real(x), imag(x)];
    X2 = [real(phase), imag(phase)];
    [U, S, V] = svd(X2'*X1);
    O = V * U';
%     if(det(O) < 0)
%         O(1, :) = -O(1, :);
%     end
    M = X1 * O;
    output = reshape(complex(M(:, 1), M(:, 2)), size(xx));
end
